SuperStrict

Import "TFRLTimer.bmx"
Import "TPlayer.bmx"

Const GFX_WIDTH:Int = 640, GFX_HEIGHT:Int = 480

Const UPDATE_FREQUENCY:Float = 100.0, SPIKE_SUPPRESSION:Int = 20

Graphics GFX_WIDTH, GFX_HEIGHT, 0

SetBlend ALPHABLEND

AutoMidHandle(True)

Global gameTime:TFRLTimer = New TFRLTimer.CreateFRL(UPDATE_FREQUENCY, SPIKE_SUPPRESSION)		'1st number is logic updates per second and 2nd number is how much spike suppression you want

Global player:TPlayer = TPlayer.Create(TCoordinate.Create(GFX_WIDTH / 2, GFX_HEIGHT / 2, 0))


' the main loop starts here
While Not KeyDown(KEY_ESCAPE) And AppTerminate() = False
	Cls
	

	' update part of the main loop with constant speed
	Local delta:Float = gameTime.ProcessTime()
	While gameTime.LogicUpdateRequired()
		DoGameLogic(gameTime.GetLogicFPS())				'Update Game Logic Here
	Wend
	
	' rendering with additional tweening	
	Local tween:Float = gameTime.GetTween()			'calc the tween for smooth graphics
	doGameRender(tween)								'Render Game Here
	
	Flip 0											' synchronize graphics buffer as soon as possible
Wend
EndGraphics
End


Function DoGameLogic(fixedRate:Float)
	' nothing here yet
	player.Update(fixedRate)
End Function

Function DoGameRender(tween:Float)
	' nothing here yet
	player.Render(tween)
	gameTime.ShowFPS(0, 0)
End Function