Type TCoordinate
	Field x:Float
	Field y:Float
	Field angle:Int	' we simplify here and just use an integer for angles between 0 and 359 degrees
	
	Function Create:TCoordinate(x:Float, y:Float, angle:Int)
		Local coord:TCoordinate = New TCoordinate
		coord.x = x
		coord.y = y
		coord.angle = angle
		Return coord
	End Function
	
	
	Function Copy:TCoordinate(original:TCoordinate)
		Local copy:TCoordinate = New TCoordinate
		copy.x = original.x
		copy.y = original.y
		copy.angle = original.angle
		Return copy
	End Function
	
	Method SetPosition(x:Float, y:Float)
		Self.x = x
		Self.y = y
	End Method
	
	Method SetAngle(angle:Int)
		self.angle = angle
	End Method
	
	Method GetDistance:Float(otherPos:TCoordinate)
		Local l1:Float = Abs(Self.x - otherPos.x)
		Local l2:Float = Abs(Self.y - otherPos.y)
		Return Sqr((l1 * l1) + (l2 * l2))
	End Method
	
	Method GetAngle:Int(otherPos:TCoordinate)
         Local dx:Float = otherPos.x - Self.x
         Local dy:Float = otherPos.y - Self.y
         Return Int((ATan2(dy:Float, dx:Float) + 360) Mod 360)
	End Method
End Type
